diff -ruN vdr-1.3.39/CONTRIBUTORS vdr-1.3.40/CONTRIBUTORS
--- vdr-1.3.39/CONTRIBUTORS	2006-01-15 16:06:19.000000000 +0100
+++ vdr-1.3.40/CONTRIBUTORS	2006-01-22 17:10:35.000000000 +0100
@@ -936,6 +936,9 @@
  for reporting a bug in handling key macros with keys after @plugin
  for adding compiler options "-fPIC -g" to all plugins
  for adding a leading '0' to the day in the DayDateTime() function
+ for reporting a crash in the Schedule menu with events that have no title
+ for a patch that was used to implement automatic cursor advance when entering text
+ via the numeric keys
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -1154,11 +1157,14 @@
  for reporting a problem with messages when a cOsdObject uses the raw OSD
  for implementing palette replace mode in the OSD bitmaps
 
-Thomas Bergwinkl <Thomas.Bergwinkl@t-online.de>
+Thomas Bergwinkl <Thomas.Bergwinkl@vr-web.de>
  for fixing the validity check for channel IDs, because some providers use TIDs
  with value 0
  for pointing out that transponder handling didn't work with satellites that provide
  two transponders on the same frequency, with different polarization
+ for fixing detecting if there can be any useful further input when entering channel
+ numbers
+ for fixing handling the '0' key for switching between the last two channels
 
 Stéphane Esté-Gracias <sestegra@free.fr>
  for fixing a typo in libsi/si.h
@@ -1655,3 +1661,25 @@
 Jürgen Schilling <juergen_schilling@web.de>
  for reporting that color buttons were displayed in the recording info menu if it
  has been invoked from a player
+
+Jesus Bravo Alvarez <jba@pobox.com>
+ for reporting a second place where a message should be given when an instant
+ recording is started
+ for updating the Spanish OSD texts
+
+Francois-Xavier Kowalski <francois-xavier.kowalski@hp.com>
+ for suggesting how to modify logging so that even on NPTL systems each line in
+ the log file shows the individual thread's pid
+
+Franz Gangkofer <Franz.Gangkofer@cadsoft.de>
+ for reporting a problem with @plugin in keymacros.conf in case the named plugin
+ is not loaded
+
+Malte Schröder <MalteSch@gmx.de>
+ for reporting a crash after executing the SVDRP command CLRE
+
+Markus Hahn <mhahn@reel-multimedia.com>
+ for suggesting to only start recordings if there is at least 300MB free disk space
+
+Jaroslaw Swierczynski <swiergot@gmail.com>
+ for updating the Polish OSD texts and the fontosd-iso8859-2.c file
diff -ruN vdr-1.3.39/HISTORY vdr-1.3.40/HISTORY
--- vdr-1.3.39/HISTORY	2006-01-15 16:05:21.000000000 +0100
+++ vdr-1.3.40/HISTORY	2006-01-22 17:10:13.000000000 +0100
@@ -4189,3 +4189,41 @@
   Ahrenberg).
 - No longer displaying color buttons in the recording info menu if it has been
   invoked from a player (reported by Jürgen Schilling).
+
+2006-01-22: Version 1.3.40
+
+- Fixed a second place where a message should be given when an instant recording
+  is started (reported by Jesus Bravo Alvarez).
+- Modified logging so that even on NPTL systems each line in the log file shows
+  the individual thread's pid (based on a suggestion from Francois-Xavier Kowalski).
+- Fixed a problem with @plugin in keymacros.conf in case the named plugin is not
+  loaded (reported by Franz Gangkofer).
+- Fixed a crash after executing the SVDRP command CLRE, caused by dangling 'schedule'
+  pointers from cChannel objects (reported by Malte Schröder).
+- Updated the Finnish OSD texts (thanks to Rolf Ahrenberg).
+- Improved NULL checking in strreplace().
+- Fixed a crash in the Schedule menu with events that have no title (reported by
+  Rolf Ahrenberg). cEvent::FixEpgBugs() now assigns a "No title" string to events
+  that have no title.
+- Updated the Estonian OSD texts (thanks to Arthur Konovalov).
+- Recordings are now only started if there is at least 300MB free disk space
+  (suggested by Markus Hahn).
+- When entering text via the numeric keys, the cursor now automatically advances
+  (based on a patch from Rolf Ahrenberg).
+- Updated the Polish OSD texts and the fontosd-iso8859-2.c file (thanks to Jaroslaw
+  Swierczynski).
+- Disabled the "buffer reserve" in Transfer Mode. Last chance to complain if you
+  really need it - it will be completely removed in the next version. If you are
+  experiencing problems with a/v running out of sync, try the latest driver and
+  firmware (if you are using a full featured DVB card).
+- Switching channels with the Up/Down or Channel+/Channel- keys now works a lot
+  faster when the repeat function kicks in, by not actually switching the
+  channel every time, but rather only displaying the channel info and doing
+  the final switch when the key is released.
+- The channel display is now updated _before_ the channel is switched.
+- Added a missing initialization of 'timeout' in the cDisplayChannel constructor.
+- Fixed detecting if there can be any useful further input when entering channel
+  numbers (thanks to Thomas Bergwinkl).
+- Updated the Spanish OSD texts (thanks to Jesus Bravo Alvarez).
+- Fixed handling the '0' key for switching between the last two channels (thanks
+  to Thomas Bergwinkl).
diff -ruN vdr-1.3.39/channels.conf vdr-1.3.40/channels.conf
--- vdr-1.3.39/channels.conf	2006-01-15 16:12:04.000000000 +0100
+++ vdr-1.3.40/channels.conf	2006-01-22 17:19:21.000000000 +0100
@@ -23,7 +23,7 @@
 VOX;RTL World:12187:hC34:S19.2E:27500:167:136=deu:71:0:12060:1:1089:0
 KABEL1;ProSiebenSat.1:12480:vC34:S19.2E:27500:511:512=deu:33:0:899:133:33:0
 DAS VIERTE,D VIERTE;BetaDigital:12460:hC34:S19.2E:27500:2047:2048=deu:36:0:1793:133:5:0
-NEUN LIVE Television,NEUN LIVE;BetaDigital:12480:vC34:S19.2E:27500:767:768=deu:35:0:897:133:33:0
+9Live;BetaDigital:12480:vC34:S19.2E:27500:767:768=deu:35:0:897:133:33:0
 DSF;BetaDigital:12480:vC34:S19.2E:27500:1023:1024=deu:39:0:900:133:33:0
 HSE24,HSE24;BetaDigital:12480:vC34:S19.2E:27500:1279:1280=deu:37:0:40:133:33:0
 Bloomberg TV Germany;Bloomberg:12551:vC56:S19.2E:22000:162:99=deu:0:0:12160:1:1108:0
@@ -46,7 +46,7 @@
 :Premiere World
 PREMIERE START,START;PREMIERE:11797:hC34:S19.2E:27500:255:256=deu:32:1801,1722,1702:8:133:2:0
 PREMIERE 1,PREM 1;PREMIERE:11797:hC34:S19.2E:27500:511:512=deu;515=deu:32:1801,1722,1702:10:133:2:0
-PREMIERE 2,PREM 2;PREMIERE:11797:hC34:S19.2E:27500:1791:1792=deu,1793=deu;1795=deu:32:1801,1722,1702:11:133:2:0
+PREMIERE 2,PREM 2;PREMIERE:11797:hC34:S19.2E:27500:1791:1792=deu;1795=deu:32:1801,1722,1702:11:133:2:0
 PREMIERE 3,PREM 3;PREMIERE:11797:hC34:S19.2E:27500:2303:2304=deu,2305=deu:32:1722,1702,1801:43:133:2:0
 PREMIERE 4,PREM 4;PREMIERE:11797:hC34:S19.2E:27500:767:768=deu,769=deu:32:1801,1722,1702:9:133:2:0
 PREMIERE 5,PREM 5;PREMIERE:11797:hC34:S19.2E:27500:1279:1280=deu:32:1722,1702,1801:29:133:2:0
@@ -65,6 +65,7 @@
 N24;ProSiebenSat.1:12480:vC34:S19.2E:27500:2047:2048=deu:36:0:47:133:33:0
 LibertyTV FR;LibertyTV.com:12610:vC56:S19.2E:22000:941:943=deu:0:0:12199:1:1112:0
 :-
+münchen.TV/RFO,müTV/RFO;BetaDigital:12148:hC34:S19.2E:27500:495:496=deu:0:0:658:133:7:0
 ProSieben Austria;ProSiebenSat.1:12051:vC34:S19.2E:27500:161:84=deu;85=deu:36:0:20002:1:1082:0
 Kabel 1 Schweiz;ProSiebenSat.1:12051:vC34:S19.2E:27500:162:163=deu:165:0:20003:1:1082:0
 Kabel 1 Austria;ProSiebenSat.1:12051:vC34:S19.2E:27500:166:167=deu:169:0:20004:1:1082:0
@@ -83,10 +84,26 @@
 Nick/Talpa;CANALDIGITAAL:12574:hC56:S19.2E:22000:512+8190:84=dut:33:622,100:5010:53:1109:0
 NICK;MTV Networks:12226:hC34:S19.2E:27500:513+8190:661=deu:577:0:28640:1:1091:0
 MTV Central;MTV Networks:11739:vC34:S19.2E:27500:3031:3032:3034:0:28653:1:1066:0
-VIVA;VIVA Fernsehen GmbH & Co. KG:12669:vC56:S19.2E:22000:309:310=deu:311:0:12732:1:1116:0
-VIVA PLUS;VIVA Fernsehen GmbH & Co. KG:12551:vC56:S19.2E:22000:171:172=deu:173:0:12120:1:1108:0
+VIVA;MTV Networks:11973:vC34:S19.2E:27500:4061+8190:4062:4064:0:28676:1:1078:0
+VIVA PLUS;MTV Networks:11973:vC34:S19.2E:27500:4071+8190:4072:4074:0:28677:1:1078:0
 QVC Deutschland;QVC:12551:vC56:S19.2E:22000:165:166:167:0:12100:1:1108:0
 TELE 5;BetaDigital:12480:vC34:S19.2E:27500:1535:1536=deu:38:0:51:133:33:0
+:NTSC
+Venevision;T-Systems/MTI:11200:vC56:S13.0E:27500:922:923=und:0:0:4750:0:13400:0
+EBC.1;T-Systems/MTI:11200:vC56:S13.0E:27500:373:374=eng:0:0:4747:0:13400:0
+:HDTV
+HDFORUM;TF1:11242:vC34:S13.0E:27500:33:36=fra:0:0:13809:100:200:0
+HDFORUM;TF1:11242:vC34:S13.0E:27500:33:36=fra:0:0:13809:318:200:0
+Euro1080 HD-5;Euro1080:10758:vC78:S23.5E:22000:34:160=eng:0:0:1085:9999:3104:0
+Euro1080;EURO1080:12168:vC56:S19.2E:27500:308:256:0:0:21100:1:1088:0
+SMD HD;SES ASTRA:12699:vC56:S19.2E:22000:133+80:234=eng:0:0:29700:0:0:0
+SMD HD:12699:V:S19.2E:22000:133:234=eng:0:0:3231:1:1118:0
+Astra HD:12441:vC34:S19.2E:27500:133+80:134=eng:0:0:29700:0:0:0
+TV HD;CSAT:12581:vC56:S19.2E:22000:165:100=fra;101=fra:0:0:9306:1:1110:0
+C M HD;Telenor:11261:hC78:S1.0W:24500:517:660=eng;661=eng:0:B00:3306:70:33:0
+C MORE HD;Telenor:11389:hC78:S1.0W:24500:512:640;641=eng:0:B00:3306:70:34:0
+HELLAS-HDTV;Scopus Network Technologies:11642:hC34:S13.0E:27500:2201:2211=ell,2212=eng:0:0:2200:318:15700:0
+TPS Star:10757:vC34:S13.0E:27500:420:430=fra,431=eng:440:500,100:1204:176:11200:0
 :@201 Sky
 Sky One;BSkyB:12226:hC23:S28.2E:27500:515+8190:643=eng:579:960,961:4705:2:2027:0
 Sky Two;BSkyB:12226:hC23:S28.2E:27500:514+8190:642=eng,662=NAR:578:960,961:5104:2:2027:0
@@ -115,10 +132,6 @@
 CNN;BSkyB:12051:vC23:S28.2E:27500:2313:2315=eng:2314:0:7140:2:2018:0
 BBC PARL'MNT;BSkyB:10847:vC56:S28.2E:22000:2327:2328=eng:2331:0:6902:2:2050:0
 IGLESIA MME;T-Systems/MTI:11200:vC56:S13.0E:27500:4097:4098:0:0:4733:318:13400:0
-Euro1080 HD-5;Euro1080:10758:vC78:S23.5E:22000:34:160=eng:0:0:1085:9999:3104:0
-Euro1080;EURO1080:12168:vC56:S19.2E:27500:308:256:0:0:21100:1:1088:0
-SMD HD;SES ASTRA:12699:vC56:S19.2E:22000:133+80:234=eng:0:0:29700:0:0:0
-Astra HD:12441:vC34:S19.2E:27500:133+80:134=eng:0:0:29700:0:0:0
 eng-WRN-multi;WRN:12597:vC34:S13.0E:27500:0:2132:0:0:8230:318:9400:0
 Challenger Tv;Telespazio:11304:hC34:S13.0E:27500:490:491:0:0:8409:318:500:0
 TVS Teleport Bonn;DMV:11535:vC34:S1.0W:5632:308+8190:256=eng,257=eng:0:3:1:65535:1:0
diff -ruN vdr-1.3.39/config.h vdr-1.3.40/config.h
--- vdr-1.3.39/config.h	2006-01-13 16:17:19.000000000 +0100
+++ vdr-1.3.40/config.h	2006-01-15 17:01:48.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 1.240 2006/01/13 15:17:19 kls Exp $
+ * $Id: config.h 1.241 2006/01/15 16:01:48 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -19,8 +19,8 @@
 #include "i18n.h"
 #include "tools.h"
 
-#define VDRVERSION  "1.3.39"
-#define VDRVERSNUM   10339  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.3.40"
+#define VDRVERSNUM   10340  // Version * 10000 + Major * 100 + Minor
 
 #define MAXPRIORITY 99
 #define MAXLIFETIME 99
diff -ruN vdr-1.3.39/epg.c vdr-1.3.40/epg.c
--- vdr-1.3.39/epg.c	2006-01-15 14:58:30.000000000 +0100
+++ vdr-1.3.40/epg.c	2006-01-20 15:09:48.000000000 +0100
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 1.49 2006/01/15 13:58:30 kls Exp $
+ * $Id: epg.c 1.51 2006/01/20 14:09:48 kls Exp $
  */
 
 #include "epg.h"
@@ -422,197 +422,196 @@
   strreplace(description, '\x86', ' ');
   strreplace(description, '\x87', ' ');
 
+  if (!title) {
+     // we don't want any "(null)" titles
+     title = strcpyrealloc(title, tr("No title"));
+     EpgBugFixStat(12, ChannelID());
+     }
+
   if (Setup.EPGBugfixLevel == 0)
      return;
 
   // Some TV stations apparently have their own idea about how to fill in the
   // EPG data. Let's fix their bugs as good as we can:
-  if (title) {
 
-     // Some channels put the ShortText in quotes and use either the ShortText
-     // or the Description field, depending on how long the string is:
-     //
-     // Title
-     // "ShortText". Description
-     //
-     if ((shortText == NULL) != (description == NULL)) {
-        char *p = shortText ? shortText : description;
-        if (*p == '"') {
-           const char *delim = "\".";
-           char *e = strstr(p + 1, delim);
-           if (e) {
-              *e = 0;
-              char *s = strdup(p + 1);
-              char *d = strdup(e + strlen(delim));
-              free(shortText);
-              free(description);
-              shortText = s;
-              description = d;
-              EpgBugFixStat(1, ChannelID());
-              }
-           }
-        }
-
-     // Some channels put the Description into the ShortText (preceded
-     // by a blank) if there is no actual ShortText and the Description
-     // is short enough:
-     //
-     // Title
-     //  Description
-     //
-     if (shortText && !description) {
-        if (*shortText == ' ') {
-           memmove(shortText, shortText + 1, strlen(shortText));
-           description = shortText;
-           shortText = NULL;
-           EpgBugFixStat(2, ChannelID());
+  // Some channels put the ShortText in quotes and use either the ShortText
+  // or the Description field, depending on how long the string is:
+  //
+  // Title
+  // "ShortText". Description
+  //
+  if ((shortText == NULL) != (description == NULL)) {
+     char *p = shortText ? shortText : description;
+     if (*p == '"') {
+        const char *delim = "\".";
+        char *e = strstr(p + 1, delim);
+        if (e) {
+           *e = 0;
+           char *s = strdup(p + 1);
+           char *d = strdup(e + strlen(delim));
+           free(shortText);
+           free(description);
+           shortText = s;
+           description = d;
+           EpgBugFixStat(1, ChannelID());
            }
         }
+     }
 
-     // Sometimes they repeat the Title in the ShortText:
-     //
-     // Title
-     // Title
-     //
-     if (shortText && strcmp(title, shortText) == 0) {
-        free(shortText);
+  // Some channels put the Description into the ShortText (preceded
+  // by a blank) if there is no actual ShortText and the Description
+  // is short enough:
+  //
+  // Title
+  //  Description
+  //
+  if (shortText && !description) {
+     if (*shortText == ' ') {
+        memmove(shortText, shortText + 1, strlen(shortText));
+        description = shortText;
         shortText = NULL;
-        EpgBugFixStat(3, ChannelID());
+        EpgBugFixStat(2, ChannelID());
         }
+     }
 
-     // Some channels put the ShortText between double quotes, which is nothing
-     // but annoying (some even put a '.' after the closing '"'):
-     //
-     // Title
-     // "ShortText"[.]
-     //
-     if (shortText && *shortText == '"') {
-        int l = strlen(shortText);
-        if (l > 2 && (shortText[l - 1] == '"' || (shortText[l - 1] == '.' && shortText[l - 2] == '"'))) {
-           memmove(shortText, shortText + 1, l);
-           char *p = strrchr(shortText, '"');
-           if (p)
-              *p = 0;
-           EpgBugFixStat(4, ChannelID());
-           }
+  // Sometimes they repeat the Title in the ShortText:
+  //
+  // Title
+  // Title
+  //
+  if (shortText && strcmp(title, shortText) == 0) {
+     free(shortText);
+     shortText = NULL;
+     EpgBugFixStat(3, ChannelID());
+     }
+
+  // Some channels put the ShortText between double quotes, which is nothing
+  // but annoying (some even put a '.' after the closing '"'):
+  //
+  // Title
+  // "ShortText"[.]
+  //
+  if (shortText && *shortText == '"') {
+     int l = strlen(shortText);
+     if (l > 2 && (shortText[l - 1] == '"' || (shortText[l - 1] == '.' && shortText[l - 2] == '"'))) {
+        memmove(shortText, shortText + 1, l);
+        char *p = strrchr(shortText, '"');
+        if (p)
+           *p = 0;
+        EpgBugFixStat(4, ChannelID());
         }
+     }
 
-     if (Setup.EPGBugfixLevel <= 1)
-        return;
+  if (Setup.EPGBugfixLevel <= 1)
+     return;
 
-     // Some channels apparently try to do some formatting in the texts,
-     // which is a bad idea because they have no way of knowing the width
-     // of the window that will actually display the text.
-     // Remove excess whitespace:
-     title = compactspace(title);
-     shortText = compactspace(shortText);
-     description = compactspace(description);
+  // Some channels apparently try to do some formatting in the texts,
+  // which is a bad idea because they have no way of knowing the width
+  // of the window that will actually display the text.
+  // Remove excess whitespace:
+  title = compactspace(title);
+  shortText = compactspace(shortText);
+  description = compactspace(description);
 
 #define MAX_USEFUL_EPISODE_LENGTH 40
-     // Some channels put a whole lot of information in the ShortText and leave
-     // the Description totally empty. So if the ShortText length exceeds
-     // MAX_USEFUL_EPISODE_LENGTH, let's put this into the Description
-     // instead:
-     if (!isempty(shortText) && isempty(description)) {
-        if (strlen(shortText) > MAX_USEFUL_EPISODE_LENGTH) {
-           free(description);
-           description = shortText;
-           shortText = NULL;
-           EpgBugFixStat(6, ChannelID());
-           }
+  // Some channels put a whole lot of information in the ShortText and leave
+  // the Description totally empty. So if the ShortText length exceeds
+  // MAX_USEFUL_EPISODE_LENGTH, let's put this into the Description
+  // instead:
+  if (!isempty(shortText) && isempty(description)) {
+     if (strlen(shortText) > MAX_USEFUL_EPISODE_LENGTH) {
+        free(description);
+        description = shortText;
+        shortText = NULL;
+        EpgBugFixStat(6, ChannelID());
         }
+     }
 
-     // Some channels put the same information into ShortText and Description.
-     // In that case we delete one of them:
-     if (shortText && description && strcmp(shortText, description) == 0) {
-        if (strlen(shortText) > MAX_USEFUL_EPISODE_LENGTH) {
-           free(shortText);
-           shortText = NULL;
-           }
-        else {
-           free(description);
-           description = NULL;
-           }
-        EpgBugFixStat(7, ChannelID());
+  // Some channels put the same information into ShortText and Description.
+  // In that case we delete one of them:
+  if (shortText && description && strcmp(shortText, description) == 0) {
+     if (strlen(shortText) > MAX_USEFUL_EPISODE_LENGTH) {
+        free(shortText);
+        shortText = NULL;
+        }
+     else {
+        free(description);
+        description = NULL;
         }
+     EpgBugFixStat(7, ChannelID());
+     }
 
-     // Some channels use the ` ("backtick") character, where a ' (single quote)
-     // would be normally used. Actually, "backticks" in normal text don't make
-     // much sense, so let's replace them:
-     strreplace(title, '`', '\'');
-     strreplace(shortText, '`', '\'');
-     strreplace(description, '`', '\'');
+  // Some channels use the ` ("backtick") character, where a ' (single quote)
+  // would be normally used. Actually, "backticks" in normal text don't make
+  // much sense, so let's replace them:
+  strreplace(title, '`', '\'');
+  strreplace(shortText, '`', '\'');
+  strreplace(description, '`', '\'');
 
-     if (Setup.EPGBugfixLevel <= 2)
-        return;
+  if (Setup.EPGBugfixLevel <= 2)
+     return;
 
-     // The stream components have a "description" field which some channels
-     // apparently have no idea of how to set correctly:
-     if (components) {
-        for (int i = 0; i < components->NumComponents(); i++) {
-            tComponent *p = components->Component(i);
-            switch (p->stream) {
-              case 0x01: { // video
-                   if (p->description) {
-                      if (strcasecmp(p->description, "Video") == 0 ||
-                           strcasecmp(p->description, "Bildformat") == 0) {
-                         // Yes, we know it's video - that's what the 'stream' code
-                         // is for! But _which_ video is it?
-                         free(p->description);
-                         p->description = NULL;
-                         EpgBugFixStat(8, ChannelID());
-                         }
-                      }
-                   if (!p->description) {
-                      switch (p->type) {
-                        case 0x01:
-                        case 0x05: p->description = strdup("4:3"); break;
-                        case 0x02:
-                        case 0x03:
-                        case 0x06:
-                        case 0x07: p->description = strdup("16:9"); break;
-                        case 0x04:
-                        case 0x08: p->description = strdup(">16:9"); break;
-                        case 0x09:
-                        case 0x0D: p->description = strdup("HD 4:3"); break;
-                        case 0x0A:
-                        case 0x0B:
-                        case 0x0E:
-                        case 0x0F: p->description = strdup("HD 16:9"); break;
-                        case 0x0C:
-                        case 0x10: p->description = strdup("HD >16:9"); break;
-                        }
-                      EpgBugFixStat(9, ChannelID());
+  // The stream components have a "description" field which some channels
+  // apparently have no idea of how to set correctly:
+  if (components) {
+     for (int i = 0; i < components->NumComponents(); i++) {
+         tComponent *p = components->Component(i);
+         switch (p->stream) {
+           case 0x01: { // video
+                if (p->description) {
+                   if (strcasecmp(p->description, "Video") == 0 ||
+                        strcasecmp(p->description, "Bildformat") == 0) {
+                      // Yes, we know it's video - that's what the 'stream' code
+                      // is for! But _which_ video is it?
+                      free(p->description);
+                      p->description = NULL;
+                      EpgBugFixStat(8, ChannelID());
                       }
                    }
-                   break;
-              case 0x02: { // audio
-                   if (p->description) {
-                      if (strcasecmp(p->description, "Audio") == 0) {
-                         // Yes, we know it's audio - that's what the 'stream' code
-                         // is for! But _which_ audio is it?
-                         free(p->description);
-                         p->description = NULL;
-                         EpgBugFixStat(10, ChannelID());
-                         }
-                      }
-                   if (!p->description) {
-                      switch (p->type) {
-                        case 0x05: p->description = strdup("Dolby Digital"); break;
-                        // all others will just display the language
-                        }
-                      EpgBugFixStat(11, ChannelID());
+                if (!p->description) {
+                   switch (p->type) {
+                     case 0x01:
+                     case 0x05: p->description = strdup("4:3"); break;
+                     case 0x02:
+                     case 0x03:
+                     case 0x06:
+                     case 0x07: p->description = strdup("16:9"); break;
+                     case 0x04:
+                     case 0x08: p->description = strdup(">16:9"); break;
+                     case 0x09:
+                     case 0x0D: p->description = strdup("HD 4:3"); break;
+                     case 0x0A:
+                     case 0x0B:
+                     case 0x0E:
+                     case 0x0F: p->description = strdup("HD 16:9"); break;
+                     case 0x0C:
+                     case 0x10: p->description = strdup("HD >16:9"); break;
+                     }
+                   EpgBugFixStat(9, ChannelID());
+                   }
+                }
+                break;
+           case 0x02: { // audio
+                if (p->description) {
+                   if (strcasecmp(p->description, "Audio") == 0) {
+                      // Yes, we know it's audio - that's what the 'stream' code
+                      // is for! But _which_ audio is it?
+                      free(p->description);
+                      p->description = NULL;
+                      EpgBugFixStat(10, ChannelID());
                       }
                    }
-                   break;
-              }
-            }
-        }
-     }
-  else {
-     // we don't want any "(null)" titles
-     title = strcpyrealloc(title, tr("No title"));
-     EpgBugFixStat(12, ChannelID());
+                if (!p->description) {
+                   switch (p->type) {
+                     case 0x05: p->description = strdup("Dolby Digital"); break;
+                     // all others will just display the language
+                     }
+                   EpgBugFixStat(11, ChannelID());
+                   }
+                }
+                break;
+           }
+         }
      }
 }
 
@@ -935,7 +934,10 @@
   cSchedulesLock SchedulesLock(true, 1000);
   cSchedules *s = (cSchedules *)Schedules(SchedulesLock);
   if (s) {
-     s->Clear();
+     for (cTimer *Timer = Timers.First(); Timer; Timer = Timers.Next(Timer))
+         Timer->SetEvent(NULL);
+     for (cSchedule *Schedule = s->First(); Schedule; Schedule = s->Next(Schedule))
+         Schedule->Cleanup(INT_MAX);
      return true;
      }
   return false;
